import processing.serial.*;

Serial puerto;
PFont numeros;
volatile int mediciones[];
volatile byte indice;
volatile float actual;
volatile boolean corriendo;
volatile int alto;
volatile boolean siguiente;
volatile int anterior;

String formateo(int numero)
{
  int decimas = numero % 100;
  int segundos = (numero - decimas) / 100;
  int minutos = segundos / 60;
  segundos -= minutos * 60;
  return nf(minutos, 2) + ":" + nf(segundos, 2) + ":" + nf(decimas, 2);
}

void setup()
{
  puerto = new Serial(this,"/dev/tty.cronometro-DevB",19200);
  numeros = loadFont("LiquidCrystal-Regular-72.vlw");
  mediciones = new int[10];
  actual = 0;
  indice = 0;
  corriendo = false;
  siguiente = false;
  size(800,800);
}

void draw()
{
  int contador;
  int suma = 0;
  int ahora = millis();
  background(0);
  color(255,255,255);
  textFont(numeros, 72);
  for(contador = 0; contador < indice; contador++)
  {
    text(nf(contador + 1, 0) + " - " + formateo(mediciones[contador]), 5, 75 + contador * 75); 
    suma += mediciones[contador];
  }
  if(corriendo)
  {
    text(formateo((int)actual), 5, 75 + contador * 75);
    suma += (int)actual;
    if(ahora - anterior >= 10)
    {
      actual += (float)(ahora - anterior) / 10;
      anterior = ahora;
    }
  }
  text("Tiempo total", 425, 250);
  text(formateo(suma), 490, 350);
  
}

void serialEvent(Serial puerto)
{
  int bajo;
  int numero;
  if(siguiente == false)
  {
    alto = puerto.read();
    println(alto);
    siguiente = true;
  }
  else
  {
    bajo = puerto.read();
    numero = (alto << 8) + bajo;
    switch(numero)
    {
      case 0:
        indice = 0;
        mediciones[indice] = 0;
        actual = 0;
        anterior = millis();
        corriendo = true;
        break;
       case 0xFFFF:
         corriendo = false;
         break;
       default:
         mediciones[indice] = numero;
         indice++;
         actual = 0;
         anterior = millis();
    }
    siguiente = false;
  }
}


